package de.fhg.iais;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

import com.linuxense.javadbf.DBFField;
import com.linuxense.javadbf.DBFReader;
import com.linuxense.javadbf.DBFWriter;

public class GDAL_WorkAround {

    public static void FixDbfEncoding(final String fileName) throws IOException {
        final File repaired = new File(fileName + "_repaired");
        final File original = new File(fileName);
        // read dbf file with patched reader

        final InputStream inputStream = new FileInputStream(original); // take dbf file as
        final DBFReader reader = new DBFReader(inputStream);
        final int numberOfFields = reader.getFieldCount();
        final DBFField[] fields = new DBFField[numberOfFields];
        for (int i = 0; i < numberOfFields; i++)
            fields[i] = reader.getField(i);
        Object[] rowObjects;
        // write dbf file with patched writer
        final DBFWriter writer = new DBFWriter();
        writer.setFields(fields);
        writer.setCharactersetName("UTF-8");
        while ((rowObjects = reader.nextRecord()) != null) {
            writer.addRecord(rowObjects);
        }

        final FileOutputStream fos = new FileOutputStream(repaired);
        writer.write(fos);
        fos.close();
        inputStream.close();
        // delete file
        if (!new File(fileName).delete())
            throw new IOException("Cannot delete fileName");
        if (!repaired.renameTo(original))
            throw new IOException("Cannot rename " + repaired.getAbsoluteFile() + " to: " + original.getAbsoluteFile());
    }
}
